Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1509833 - [Disperse] : Improve heal info command to handle obvious cases
Summary: [Disperse] : Improve heal info command to handle obvious cases
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: disperse
Version: rhgs-3.4
Hardware: Unspecified
OS: Unspecified
high
medium
Target Milestone: ---
: RHGS 3.4.0
Assignee: Ashish Pandey
QA Contact: Sri Vignesh Selvan
URL:
Whiteboard:
Depends On: 1476668 1522623
Blocks: 1503134
TreeView+ depends on / blocked
 
Reported: 2017-11-06 07:37 UTC by Sunil Kumar Acharya
Modified: 2018-09-04 07:28 UTC (History)
8 users (show)

Fixed In Version: glusterfs-3.12.2-2
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 1476668
Environment:
Last Closed: 2018-09-04 06:39:09 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2018:2607 None None None 2018-09-04 06:40:27 UTC

Description Sunil Kumar Acharya 2017-11-06 07:37:58 UTC
+++ This bug was initially created as a clone of Bug #1476668 +++

Description of problem:

If an update fop (data) is going on for a file, its index entry will be present in .glustrfs/indeices.
Now, If a brick is down and we run heal info on EC volume, it is obvious that this file needs heal. There is no need of taking lock and slowing down heal info command.



Version-Release number of selected component (if applicable):


How reproducible:
100%

Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:

--- Additional comment from Worker Ant on 2017-07-31 03:44:23 EDT ---

REVIEW: https://review.gluster.org/17923 (cluster/ec: Improve heal info command to handle obvious cases) posted (#1) for review on master by Ashish Pandey (aspandey@redhat.com)

--- Additional comment from Worker Ant on 2017-10-09 13:20:42 EDT ---

REVIEW: https://review.gluster.org/17923 (cluster/ec: Improve heal info command to handle obvious cases) posted (#2) for review on master by Ashish Pandey (aspandey@redhat.com)

--- Additional comment from Worker Ant on 2017-10-11 06:27:54 EDT ---

REVIEW: https://review.gluster.org/17923 (cluster/ec: Improve heal info command to handle obvious cases) posted (#3) for review on master by Ashish Pandey (aspandey@redhat.com)

--- Additional comment from Worker Ant on 2017-10-15 22:40:05 EDT ---

COMMIT: https://review.gluster.org/17923 committed in master by Pranith Kumar Karampuri (pkarampu@redhat.com) 
------
commit d88be3bc29dbd1eaa393802f3c98e188fe5287c8
Author: Ashish Pandey <aspandey@redhat.com>
Date:   Mon Jul 31 12:45:21 2017 +0530

    cluster/ec: Improve heal info command to handle obvious cases
    
    Problem:
    1 - If a brick is down and we see an index entry in
    .glusterfs/indices, we should show it in heal info
    output as it most certainly needs heal.
    
    2 - The first problem is also not getting handled after
    ec_heal_inspect. Even if in ec_heal_inspect, lookup will
    mark need_heal as true, we don't handle it properly in
    ec_get_heal_info and continue with locked inspect which
    takes lot of time.
    
    Solution:
    1 - In first case we need not to do any further invstigation.
    As soon as we see that a brick is down, we should say that
    this index entry needs heal for sure.
    
    2 - In second case, if we have need_heal as _gf_true after
    ec_heal_inspect, we should show it as heal requires.
    
    Change-Id: Ibe7f9d7602cc0b382ba53bddaf75a2a2c3326aa6
    BUG: 1476668
    Signed-off-by: Ashish Pandey <aspandey@redhat.com>

Comment 2 Sunil Kumar Acharya 2017-11-06 07:39:23 UTC
upstream patch : https://review.gluster.org/17923

Comment 5 Sri Vignesh Selvan 2018-07-23 07:00:51 UTC
Build version :
---------------
glusterfs-3.12.2-14.el7rhgs.x86_64

When the brick is down, Index entries are displayed in .glusterfs/indices and files requires heal are getting listed in heal info output.

Hence moving this bug to verified.

Comment 7 errata-xmlrpc 2018-09-04 06:39:09 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2018:2607


Note You need to log in before you can comment on or make changes to this bug.